/* Copyright (c) 1997-2008
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_COMMON_PERL_BINDINGS_GenericStruct_H
#define _POLYMAKE_COMMON_PERL_BINDINGS_GenericStruct_H "$Project: polymake $$Id: GenericStruct.h 8962 2008-12-03 15:47:54Z gawrilow $"

#include_next <GenericStruct.h>
#include <polymake.h>

namespace pm { namespace perl {

   template <typename Struct, int i>
   struct StructUtils_helper {
      typedef typename Struct::field_types type_list;
      static const int next= i+1 < list_length<type_list>::value ? i+1 : i;
      typedef StructUtils_helper<Struct,next> recurse_down;
      typedef typename n_th<type_list,i>::type T;

      static SV** _do_push(SV **stack)
      {
	 pm_perl_sync_stack(stack);
	 SV *Tproto=type_cache<T>::get_proto();
	 if (!Tproto) return 0;
	 size_t nl;
	 const char *n=Struct::get_field_name(nl,int2type<i>());
	 stack=pm_perl_push_string_arg(stack,n,nl);
	 stack=pm_perl_push_arg(stack, Tproto);
	 return next>i ? recurse_down::_do_push(stack) : stack;
      }
   };

   template <typename Struct>
   struct StructUtils {
      static SV** (*push())(SV **stack) { return &StructUtils_helper<Struct,0>::_do_push; }
   };

   template <typename Struct, size_t pkgl, bool exact_match>
   SV4recognize<exact_match>* get_Struct_type(const char (&pkg)[pkgl], bool2type<exact_match>)
   {
      return static_cast<SV4recognize<exact_match>*>(get_type(pkg,pkgl-1,StructUtils<Struct>::push(),exact_match));
   }
} }

namespace polymake { namespace perl_bindings {
   template <typename T, typename Struct>
   pm::perl::SV4recognize<pm::identical<T, Struct>::value>* recognize(bait*, T*, GenericStruct<Struct>*)
   {
      return pm::perl::get_Struct_type<Struct>("Polymake::common::Tuple", pm::identical<T, Struct>());
   }

///==== Automatically generated contents follow.    Please do not delete this line. ====
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }

#endif // _POLYMAKE_COMMON_PERL_BINDINGS_GenericStruct_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
