/* Copyright (c) 1997-2008
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: lrs_lp_client.cc 8902 2008-11-10 14:39:35Z joswig $"

#include <lp_client.h>
#include <lrs_interface.h>

namespace polymake { namespace polytope {

   void lrs_solve_lp(perl::Object p, perl::Object lp, bool maximize)
   {
      lrs_interface::solver solver;
      solve_lp(p, lp, solver, maximize);
   }

   void lrs_valid_point(perl::Object p)
   {
      lrs_interface::solver solver;
      valid_point(p, solver);
   }

   Function4perl(&lrs_solve_lp, "lrs_solve_lp(Polytope<Rational>, LinearProgram<Rational>, $)");
   Function4perl(&lrs_valid_point, "lrs_valid_point(Polytope<Rational>)");
} }
