/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: staircase_weight.cc 8207 2008-07-08 16:17:54Z sherrmann $"

#include <Rational.h>
#include <polymake.h>
#include <Vector.h>


namespace polymake { namespace polytope {

Vector<Rational> staircase_weight(const int k, const int l) {
  
  Vector<Rational> weight(k*l);
  int index=0;
  for (int i=1; i<=k; ++i)
    for (int j=k+1; j<=k+l; ++j) {
      weight[index++]=(k-i)*(j-k-1)+(i-1)*(k+l-j);
    }

  return weight;;
}


  UserFunction4perl("# Gives a weight vector for the staircase triangulation of\n"
		    "# the product of a @a k- and an @a l- dimensional simplex.\n"
		    "# args: k l",
		    &staircase_weight,"staircase_weight"); 

} }
