/* Copyright (c) 1997-2007
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: vertex_barycenter.cc 7858 2008-01-02 22:33:38Z gawrilow $"

#include <polymake.h>
#include <Matrix.h>
#include <Vector.h>

namespace polymake { namespace polytope {

template <typename E>
Vector<E> barycenter(const Matrix<E>& V)
{
   return average(rows(V));
}

FunctionTemplate4perl("barycenter(Matrix)");

} }
